/*
Created by: X
http://www.createdbyx.com/

The Zider engine is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
                using Microsoft.Xna.Framework;
                using Microsoft.Xna.Framework.Graphics;

namespace Zider
{
    public abstract class Block
    {
        internal protected Texture2D tex;
        internal protected Rectangle sourceRect;
        internal protected Color color = Color.White;
        private string textureName = string.Empty;
        private bool textureNeedsUpdate = true;
        private Zider.GetTexture getTex;

        public Zider.GetTexture GetTexture
        {
            get { return getTex; }
            set { getTex = value; }
        }

        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public virtual void Update(GameTime gameTime)
        {
            // TODO: Add your update code here
            if (this.getTex != null && textureNeedsUpdate)
            {
                Texture2D t;
                if (this.getTex(textureName, out t))
                {
                    this.tex = t;
                    textureNeedsUpdate = false;
                }
            }
        }

        public string TextureName
        {
            get { return textureName; }
            set
            {
                textureName = value;
                textureNeedsUpdate = true;
            }
        }


        public Color Color
        {
            get { return color; }
            set { color = value; }
        }       	

        public Rectangle SourceRectangle
        {
            get { return sourceRect; }
            set { sourceRect = value; }
        }

        public int SourceLeft
        {
            get { return sourceRect.X; }
            set { sourceRect.X = value; }
        }

        public int SourceTop
        {
            get { return sourceRect.Y; }
            set { sourceRect.Y = value; }
        }

        public int SourceWidth
        {
            get { return sourceRect.Width; }
            set { sourceRect.Width = value; }
        }

        public int SourceHeight
        {
            get { return sourceRect.Height; }
            set { sourceRect.Height = value; }
        }

        public Texture2D Texture
        {
            get { return tex; }
            set { tex = value; }
        }
    }
}
