using System;
using System.Collections.Generic;
using System.Text;
using xFripperyXNA;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Zider.Classes.Widgets
{
    public class ConsoleWidget : Classes.GUIWidget
    {
        private Classes.GUIWidget centerWidget;
        private bool mouseIsDown = false;
        private Vector2 offset;

        public Vector2 Offset
        {
            get { return offset; }
            set { offset = value; }
        }


        public override void Initilize(ZiderGame game)
        {
            // call base init 
            base.Initilize(game);

            // search for left and right texture button controls
            this.centerWidget = this.children.FindControl<Classes.GUIWidget>("center", true, true);
            this.centerWidget.MouseDown += new MouseDownEventHandler(this.Mouse_Down);
            this.centerWidget.MouseMove += new MouseMoveEventHandler(this.Mouse_Move);
            this.centerWidget.MouseUp += new MouseUpEventHandler(this.Mouse_Up);
        }

        private void Mouse_Down(object sender, MouseButtons b, Vector2 pos)
        {
            switch (b)
            {
                case MouseButtons.Left:
                    this.offset += (pos - this.offset);
                    this.mouseIsDown = true;
                    break;
            }

        }

        private void Mouse_Move(object sender, MouseButtons b, Vector2 pos)
        {
            switch (b)
            {
                case MouseButtons.Left:
                    if (mouseIsDown)
                    {
                        this.offset += (pos - this.offset);
                    }
                    break;
            }
        }

        private void Mouse_Up(object sender, MouseButtons b, Vector2 pos)
        {
            switch (b)
            {
                case MouseButtons.Left:
                    this.mouseIsDown = false;
                    break;
            }

        }
    }
}
