/*
Created by: X
http://www.createdbyx.com/

The Zider engine is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/

#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
#endregion

namespace Zider.Components
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public partial class GUIRenderer : Microsoft.Xna.Framework.DrawableGameComponent
    {
        private System.Collections.Generic.Dictionary<string, Interfaces.IDesktopComponent> desktop = new Dictionary<string, Interfaces.IDesktopComponent>();
        internal protected SpriteBatch sb;
        internal protected ZiderGame game;

          
        public System.Collections.Generic.Dictionary<string, Interfaces.IDesktopComponent> Desktop
        {
            get { return desktop; }
        }

        public void Clear()
        {
            this.desktop.Clear();
        }

        public void Add(string name, Interfaces.IDesktopComponent dc)
        {
            this.desktop.Add(name, dc);
        }

        public GUIRenderer(ZiderGame game) : base(game)
        {
            // TODO: Construct any child components here
            this.game = game;
        }

        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here

            base.Initialize();
            sb = new SpriteBatch(this.GraphicsDevice);
        }


        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // update widgets
            foreach (string key in this.desktop.Keys)
            {
                this.desktop[key].Update(this.game, gameTime);
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// Allows the game component to draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Draw(GameTime gameTime)
        {
            // TODO: Add your draw code here
            sb.Begin(SpriteBlendMode.AlphaBlend);
            foreach (string key in this.desktop.Keys)
            {
                this.desktop[key].Draw(gameTime, this.sb);// DrawControl(this.desktop[key], true);
            }
            sb.End();

            base.Draw(gameTime);
        }
    }
}


