/*
Created by: X
http://www.createdbyx.com/

The Zider engine is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/

#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
#endregion

namespace Zider.Components
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public partial class InputManager : Microsoft.Xna.Framework.GameComponent
    {
        private Collections.CommandList commands = new Zider.Collections.CommandList();
        internal protected ZiderGame game;


        public Zider.ZiderGame Engine 
        {
            get { return game; }
        }
        
        public Collections.CommandList Commands
        {
            get { return commands; }
        }
	
        public InputManager(ZiderGame game)
            : base(game)
        {
            // TODO: Construct any child components here
            this.game = (ZiderGame)game;
        }


        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here

            base.Initialize();
        }


        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // update top level comand                        
            LinkedListNode<Interfaces.ICommand> cmd = this.commands.First;
            while (cmd != null)
            {
                cmd.Value.Update(gameTime);
                if (cmd.Value.Result == Zider.Interfaces.CommandResult.Continue)
                {
                    cmd = cmd.Next;
                }
                else
                {
                    break;
                }
            }
            base.Update(gameTime);
        }
    }
}


