/*
Created by: X
http://www.createdbyx.com/

The Zider engine is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/

#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
#endregion

namespace Zider.Components
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public partial class MapRenderer : Microsoft.Xna.Framework.DrawableGameComponent
    {
        protected SpriteBatch sb;
        protected ZiderGame game;

        public MapRenderer(ZiderGame game)
            : base(game)
        {
            // TODO: Construct any child components here
            this.game = (ZiderGame)game;
        }

        //protected override void LoadGraphicsContent(bool loadAllContent)
        //{
        //    sb = new SpriteBatch(this.GraphicsDevice);
            
        //    base.LoadGraphicsContent(loadAllContent);
        //}
        //protected override void UnloadGraphicsContent(bool unloadAllContent)
        //{
        //    sb.Dispose();
        //    base.UnloadGraphicsContent(unloadAllContent);
        //}

        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here
            base.Initialize();
           sb = new SpriteBatch(this.GraphicsDevice);
        }


        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // TODO: Add your update code here

            base.Update(gameTime);
        }

        /// <summary>
        /// Allows the game component to draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Draw(GameTime gameTime)
        {
            Map map = game.CurrentMap;

            // draw map
            sb.Begin();
            for (int idy = 0; idy <= map.MapHeight - 1; idy++)
            {
                for (int idx = 0; idx <= map.MapWidth - 1; idx++)
                {
                    Block b; // block ref
                    b = map.GetBlock(idx, idy);
                    if (b != null)
                    {
                        Rectangle dr; // dest rect
                        int bw, bh; // block width and height
                        bw = (int)map.BlockWidth;
                        bh = (int)map.BlockHeight;
                        dr = new Rectangle(idx * bw, idy * bh, bw, bh);
                        dr.X -= (int)this.game.cam.Position.X;
                        dr.Y -= (int)this.game.cam.Position.Y;
                                           
                        // call update before drawing
                        b.Update(gameTime);
                        
                        // Draw block
                        sb.Draw(b.Texture, dr, b.SourceRectangle, b.Color, 0, Vector2.Zero, SpriteEffects.None, 0f);
                    }
                }
            }
            sb.End();

            base.Draw(gameTime);
        }

    }
}


