/*
Created by: X
http://www.createdbyx.com/

The Zider engine is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;

namespace Zider.Controllers
{
    public class ButtonTexturesWidgetValue : Axiom.Controllers.IControllerValue
    {

        public enum SourceValue
        {
            Left_SourceLeft,
            Left_SourceTop,
            Left_SourceWidth,
            Left_SourceHeight,
            Right_SourceLeft,
            Right_SourceTop,
            Right_SourceWidth,
            Right_SourceHeight
        }
        
        private SourceValue source;
        private Classes.Widgets.ButtonTexturesWidget btw;

        public Classes.Widgets.ButtonTexturesWidget ButtonTextureWidget
        {
            get { return btw; }
            set { btw = value; }
        }

        public SourceValue ValueSource
        {
            get { return source; }
        }

        public ButtonTexturesWidgetValue(Classes.Widgets.ButtonTexturesWidget w, SourceValue s)
        {
            this.source = s;
            this.btw = w;
        }

        #region IControllerValue Members

        public float Value
        {
            get
            {
                switch (this.source)
                {
                    case SourceValue.Left_SourceLeft:
                        return btw.LeftWidget.SourceLeft;

                    case SourceValue.Left_SourceTop:
                        return btw.LeftWidget.SourceTop;

                    case SourceValue.Left_SourceWidth:
                        return btw.LeftWidget.SourceWidth;

                    case SourceValue.Left_SourceHeight:
                        return btw.LeftWidget.SourceHeight;

                    case SourceValue.Right_SourceLeft:
                        return btw.RightWidget.SourceLeft;

                    case SourceValue.Right_SourceTop:
                        return btw.RightWidget.SourceTop;

                    case SourceValue.Right_SourceWidth:
                        return btw.RightWidget.SourceWidth;

                    case SourceValue.Right_SourceHeight:
                        return btw.RightWidget.SourceHeight;  
                }

                // should not happen
                throw new Exception();
            }
            set
            {
               // btw.SetValue(this.source, (int)value);
                switch (this.source)
                {
                    case SourceValue.Left_SourceLeft:
                        btw.LeftWidget.SourceLeft = (int)value;
                        break;

                    case SourceValue.Left_SourceTop:
                        btw.LeftWidget.SourceTop = (int)value;
                        break;

                    case SourceValue.Left_SourceWidth:
                        btw.LeftWidget.SourceWidth = (int)value;
                        break;

                    case SourceValue.Left_SourceHeight:
                        btw.LeftWidget.SourceHeight = (int)value;
                        break;

                    case SourceValue.Right_SourceLeft:
                        btw.RightWidget.SourceLeft = (int)value;
                        break;

                    case SourceValue.Right_SourceTop:
                        btw.RightWidget.SourceTop = (int)value;
                        break;

                    case SourceValue.Right_SourceWidth:
                        btw.RightWidget.SourceWidth = (int)value;
                        break;

                    case SourceValue.Right_SourceHeight:
                        btw.RightWidget.SourceHeight = (int)value;
                        break;

                }
               //   should not happen
                throw new Exception();

            }
        }

        #endregion
    }
}
