/*
Created by: X
http://www.createdbyx.com/

The Zider engine is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;

namespace Zider.Controllers
{
    public class MapSize : Axiom.Controllers.IControllerValue, IDisposable
    {
        public enum SourceValue
        {
            Width,
            Height
        }

        private SourceValue source;
        private Map map;


        public MapSize(Map m, SourceValue s)
        {
            this.map = m;
            this.source = s;
        }

        public SourceValue Source
        {
            get { return source; }
        }
	
        public Map Map
        {
            get { return map; }
            set { map = value; }
        }
	
        #region IControllerValue Members

        public float Value
        {
            get
            {
                switch (this.source)
                {
                    case SourceValue.Width:
                        return this.map.mapWidth * this.map.blockWidth;

                    case SourceValue.Height:
                        return this.map.mapHeight * this.map.blockHeight;
                }

                // should not happen
                throw new Exception();
            }
            set
            {
                // do nothing
                throw new NotImplementedException("Setting the map size has not yet been implemented.");
            }
        }

        #endregion

        #region IDisposable Members

        public void Dispose()
        {
            this.map = null;
        }

        #endregion
    }
}
