/*
Created by: X
http://www.createdbyx.com/

The Zider engine is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;

namespace Zider.Controllers
{
    public class RectangleInfoValue : Axiom.Controllers.IControllerValue
    {
        public enum SourceValue
        {
            Left,
            Top,
            Width,
            Height
        }

        private Components.RectangleRenderer.RectangleInfo rectInfo;
        private SourceValue source;

        public SourceValue Source
        {
            get { return source; }
        }

        public Components.RectangleRenderer.RectangleInfo RectangleInfo
        {
            get { return rectInfo; }
            set { rectInfo = value; }
        }

        public RectangleInfoValue(Components.RectangleRenderer.RectangleInfo r, SourceValue s)
        {
            this.source = s;
            this.rectInfo = r;
        }

        #region IControllerValue Members

        public float Value
        {
            get
            {
                switch (this.source)
                {
                    case SourceValue.Left:
                        return this.rectInfo.rect.Left;

                    case SourceValue.Top:
                        return this.rectInfo.rect.Top;

                    case SourceValue.Width:
                        return this.rectInfo.rect.Width;

                    case SourceValue.Height:
                        return this.rectInfo.rect.Height;
                }

                // should not happen
                throw new Exception();
            }
            set
            {
                switch (this.source)
                {
                    case SourceValue.Left:
                        this.rectInfo.rect.X = (int)value;
                        break;

                    case SourceValue.Top:
                        this.rectInfo.rect.Y = (int)value;
                        break;

                    case SourceValue.Width:
                        this.rectInfo.rect.Width = (int)value;
                        break;

                    case SourceValue.Height:
                        this.rectInfo.rect.Height = (int)value;
                        break;
                }
            }
        }

        #endregion
    }
}
