/*
Created by: X
http://www.createdbyx.com/

xFripperyXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;

namespace xFripperyXNA
{
    public static class Helpers
    {
        public static IControl FindControl(IControl Ctrl, string Name, bool SearchChildren, bool ignoreCase)
        {
            if (string.Compare(Ctrl.Name, Name, ignoreCase) == 0)
            {
                return Ctrl;
            }
            foreach (IControl c in Ctrl.Children)
            {
                if (string.Compare(c.Name, Name, ignoreCase) == 0)
                {
                    return c;
                }
                if (SearchChildren)
                {
                    IControl Tmp;
                    Tmp = FindControl(c, Name, SearchChildren, ignoreCase);
                    if (Tmp != null)
                    {
                        return Tmp;
                    }
                }
            }
            return null;
        }

        public static T FindControl<T>(T Ctrl, string Name, bool SearchChildren, bool ignoreCase) where T : IControl
        {
            if (string.Compare(Ctrl.Name, Name, ignoreCase) == 0)
            {
                return Ctrl;
            }
            foreach (T c in Ctrl.Children)
            {
                if (string.Compare(c.Name, Name, ignoreCase) == 0)
                {
                    return c;
                }
                if (SearchChildren)
                {
                    T Tmp;
                    Tmp = FindControl(c, Name, SearchChildren, ignoreCase);
                    if (Tmp != null)
                    {
                        return Tmp;
                    }
                }
            }
            return default(T);
        }
    }
}
